<?php

// ------------------------------------------------------------------------------
// CALLBACK FUNCTION FOR: add_action('admin_init', 'byobtshw_init' )
// ------------------------------------------------------------------------------


// Init plugin options to white list our options
function byobtshw_init(){

    register_setting( 'byobtshw_plugin_options', 'byobtshw_options', 'byobtshw_validate_options' );
    wp_register_style( 'byobtshw-options-stylesheet', plugins_url('options.css', __FILE__) );
        
    wp_enqueue_style('byobtshw-options-stylesheet');
    wp_enqueue_style('thesis-options-stylesheet', THESIS_CSS_FOLDER . '/options.css');
    wp_enqueue_script('color-picker', THESIS_SCRIPTS_FOLDER . '/jscolor/jscolor.js');
    wp_enqueue_script('jquery-ui-core'); #wp
    wp_enqueue_script('jquery-ui-sortable'); #wp
    wp_enqueue_script('jquery-ui-tabs'); #wp
    wp_enqueue_script('thesis-admin-js', THESIS_SCRIPTS_FOLDER . '/thesis.js');
}


// ------------------------------------------------------------------------------
// CALLBACK FUNCTION FOR: add_action('admin_menu', 'byobtshw_add_options_page');
// ------------------------------------------------------------------------------
// THIS FUNCTION RUNS WHEN THE 'admin_menu' HOOK FIRES, AND ADDS A NEW OPTIONS
// PAGE FOR YOUR PLUGIN TO THE SETTINGS MENU.
// ------------------------------------------------------------------------------

// Add menu page
function byobtshw_add_options_page() {
    global $_registered_pages;
      $pages = array();
      $pages = $_registered_pages;
    if(!$_registered_pages || !key_exists('toplevel_page_byob-thesis-plugins', $pages)){
        add_menu_page( 'BYOB Thesis Plugins', 'BYOB Thesis Plugins', 'manage_options', 'byob-thesis-plugins','byobtshw_render_byob_plugins_page', BYOBTSHW_PLUGIN_URL .'images/byob-icon-small.png');
    }
    $this_options_page = add_submenu_page('byob-thesis-plugins', 'BYOB Thesis Simple Header Widgets', 'Simple Header Widgets', 'manage_options', __FILE__, 'byobtshw_render_form');
    
    
    $text = '<div class="metabox-prefs"><h2>BYOB Thesis Header Widgets Help</h2>';
    $text .= '<p>This plugin allows you to add widgets to the Thesis Header without creating custom code.  With it you can do any of the following:</p>';
    $text .= '<ul><li>Divide the header into left and right sides</li>';
    $text .= '<li>Add widgets to either side or both sides</li>';
    $text .= '<li>Define the height, width, background color and background image of the header area</li>';
    $text .= '<li>Define the height, width, background color and background image of either side of the header area</li>';
    $text .= '<li>Define the padding and margins for either side of the header area and for the entire header area</li>';
    $text .= '<li>Retain the default Thesis header functions for one of the sides(either left or right)</ul></li>';
    $text .= '<p style="color:blue;">Remember you set the default Thesis header options in Thesis Design Options and Thesis Header Image</p>';
    $text .= '<h3 style="border-top:#dddddd 1px solid;padding-top:10px;">Overall Header Area</h3>';
    $text .= '<p>This section allows you to set the options for the header container.  This container holds both the left and right header areas.';
    $text .= ' This header area is then divided into left and right sides (if only one header area is selected then only the left side is created).</p>';
    $text .= '<h3 style="border-top:#dddddd 1px solid;padding-top:10px;">Header Layout</h3>';
    $text .= '<p>This section gives you a graphic representation of the header and the configuration of the header areas.';
    
    $text .= '<h3 style="border-top:#dddddd 1px solid;padding-top:10px;">Determine where to place the CSS</h3>';
    $text .= '<p>CSS is the code that determines what your website looks like.  This plugin generates custom CSS based on the settings you choose.
            The choice you make here will <strong>slightly</strong> affect the speed of your site.  You have 2 choices:</p>';
    $text .= '<ul><li><strong>In the Head</strong> - This will write the CSS code to the head section of every page.  <span style="color:blue;">Choose this option if you
            are only using one or two BYOB Thesis Plugins.</span>  It will save an HTTP request.  Which will be slightly faster</li>';
    $text .= '<li><strong>In a separate file</strong> - This will write the code to a file called byob-custom.css, located in your custom folder.
            <span style="color:blue;">Choose this if you are using more than two of the BYOB Thesis Plugins.</span>  You will get an http request but the browser will cache the
            CSS file and it will not need to download it again.  This saves time on larger files.</li></ul>';
    $text .= '<h3 style="border-top:#dddddd 1px solid;padding-top:10px;">Left Header Area</h3>';
    $text .= '<p>This section allows you to set the options for the Left Header Area.  You can choose to retain default Thesis header functions as well as include the Thesis Nav Menu and Search Form.';
    $text .= ' Additional options become available if you choose to include a menu or search form in this area.</p>';

    $text .= '</div>';
    
    add_contextual_help( $this_options_page, $text );
}

// ------------------------------------------------------------------------------
// CALLBACK FUNCTION SPECIFIED IN: add_options_page()
// ------------------------------------------------------------------------------
// THIS FUNCTION IS SPECIFIED IN add_options_page() AS THE CALLBACK FUNCTION THAT
// ACTUALLY RENDER THE PLUGIN OPTIONS FORM AS A SUB-MENU UNDER THE EXISTING
// SETTINGS ADMIN MENU.
// ------------------------------------------------------------------------------

// Render the Plugin options form


// Render the Plugin options form
function byobtshw_render_byob_plugins_page() {
	?>
	<div class="wrap">
		
		<!-- Display Plugin Icon, Header, and Description -->
		<div class="icon32"><img src="<?php echo BYOBTSHW_PLUGIN_URL . 'images/byob-icon.png';?>" /><br></div>
		<h2>BYOB Thesis Thesis Plugins</h2>
                <h4 style="color:orange">Premium members of BYOBWebsite.com have access to a number of specialized plugins for Thesis</h4>
		<p><strong>These plugins have been created in order to extend custom functionality to beginners and to save time for experts</strong></p>
                <p><a href="http://www.byobwebsite.com/plugins/">View a Complete List of Plugins available to members</a></p>
                <p><a href="http://www.byobwebsite.com/forum/">Get support and help using these plugins at our forum</a></p>
                <h2>Current Plugins Available</h2>
                <h3 style="border-top:#dddddd 1px solid;padding-top:10px;">BYOB Thesis Feature Box</h3>
                <p>This plug allows you to access the feature box without having to add your own custom programming.  You can<br />
                choose to widgetize it, add custom HTML to it, or activate plugins like the Dynamic Content Gallery.</p>
                <h3 style="border-top:#dddddd 1px solid;padding-top:10px;">BYOB Thesis Footer Widgets</h3>
                <p>This plugin allows you to create up to 3 rows of widgets, each with a maximum of 5 columns of widgets in the Thesis footer.
                You can mix and match the number of widget columns in each row and can specify the width of each widget column.  You can also
                customize the styling of the widget areas.  This plugin is only available via our Facebook Fan Page</p>
                <h3 style="border-top:#dddddd 1px solid;padding-top:10px;">BYOB Thesis Header Widgets</h3>
                <p>This plug allows you to create one or two widget areas in the Thesis header.  Using it any widget can be placed in the Thesis header.
                You can either retain or replace the default Thesis header behavior.  You can also add the Thesis Nav Menu and or the search form to either of the header areas.  You can also
                customize the styles for each of the header areas.</p>
                <h3 style="border-top:#dddddd 1px solid;padding-top:10px;">BYOB Thesis Landing Pages</h3>
                <p>This plug allows you to create landing pages by removing the Thesis header, footer and sidebars directly <br />
                from the post or page edit screen</p>
                <h3 style="border-top:#dddddd 1px solid;padding-top:10px;">BYOB Thesis Mobile Content Switcher</h3>
                <p>This plug allows you to display content designed specifically for mobile devices on any post or page.  It will automatically detect
                a mobile device and will then replace the non mobile content for the mobile content.  You can have an unlimited number of switched blocks of 
                content on any post or page</p>                
                <h3 style="border-top:#dddddd 1px solid;padding-top:10px;">BYOB Thesis Navigation Menu</h3>
                <p>This plug allows you to change a number of the default Thesis settings for the navigation menu.  Using this plugin<br />
                you can locate the menu either above or below the header, make the menu span the full width of the page, center the <br />
                navigation menu, and change default menu text styling.</p>
                <h3 style="border-top:#dddddd 1px solid;padding-top:10px;">BYOB Thesis Sub Sidebars</h3>
                <p>This plug allows you to create "Sub Sidebars" that can be placed within either of the default Thesis sidebars.  Once created you
                can select which Sub Sidebars will be displayed on each post or page from the post or page edit screen.  These sidebars will show up in
                your sidebar list and you can drag any widgets into the sidebars.</p>                
                <h3 style="border-top:#dddddd 1px solid;padding-top:10px;">BYOB Thesis WP Menus</h3>
                <p>This plug allows you to create an unlimited number of WordPress menus and place them virtually anywhere on your site.  It also allows
                You to create new menu styles and apply those styles to the new WordPress menus.  The process of creating a new menu style is very much
                the same as styling the Thesis Nav Menu.  It also adds additional styling options for the Thesis Nav Menu.  It can work along side of the 
                BYOB Thesis Nav Menu plugin.</p>
	</div>
	<?php	
}


// ------------------------------------------------------------------------------
//  CALLBACK FUNCTION for  byobtshw_render_form()
//  Tests to see if the thesis/custom/ or thesis/custom-sample/ directories exist
//  and are writeable.  If not an error message is displayed on the plugin options
//  form
// ------------------------------------------------------------------------------

function byobtshw_writeable_check(){
    $custom_file = STYLESHEETPATH . '/custom';
    $custom_sample_file = STYLESHEETPATH . '/custom-sample';
    $writeable_message = '<p>Your Thesis Custom Folder is not writeable.  For best results, change the permissions on your Thesis 
        Custom Folder.  This typically should be 755, but may need to be 775 or 777 on some hosts.  If you have problems with this
        contact your hosting provider.</p>';
    
    if(is_writable($custom_file)){
        $writeable_message = '';
    }elseif(is_writable($custom_sample_file)){
         $writeable_message = '';
    }
    
    return  $writeable_message;
}
